\ 
\ Last_change: KS 16.01.2012 18:18:59
\ 
\ The example from Berds article in the VD 4/2011, page 29/30 can now be
\ implemented as follows:
\
\ now implemented using simpleOOP by Klaus Schleisiek
\
\ some re-definitions to adapt to Manfred's syntax:

include oop.fs

: msg   polymorphic ;
Classroot definitions
: New   Classroot Object ;
: ::    Classroot Attribute ;

Forth definitions

\ The example follows here now:

class aCell aCell definitions 1 cells self allot
\ ----------------------------------------------------
: @ ( oid -- u ) ( forth ) @ ;
: ! ( u oid -- ) ( forth ) ! ;


forth definitions

class MemVar MemVar definitions
\ ---------------------------------------------------
aCell :: addr

msg @ ( self -- x )
msg ! ( x self -- )

: init ( addr self -- ) self addr ! ; \ early binding to aCell !

: ? ( self -- ) self @ . ; \ late binding to @

: +! ( x self -- ) dup >r self @ + r> self ! ; \ late binding to @ and !

\ +! will late bind to the following methods when applied to a MemVar

: ! ( x self -- ) self addr @ ! ;
: @ ( self -- x ) self addr @ @ ;

forth definitions

: flash! ( x a -- ) ." flash store " ! ; \ a dummy to simulate flash access

MemVar Class FlashVar  FlashVar definitions
\ ---------------------------------------------
: ! ( x self -- ) self addr @ flash! ;
\ This method is early bound to a FlashVar Instance but late bound to the +!
\ and ? methods defined in MemVar, when those are applied to a FlashVar
\ Instance.


forth definitions

: spi! ( x a -- ) ." spi store " ! ; \ a dummy to simulate write access
: spi@ ( a -- x ) ." spi fetch " @ ; \ a dummy to simulate read access

MemVar Class SpiVar SpiVar definitions
\ ---------------------------------------------
: ! ( x self -- ) self addr @ spi! ;
: @ ( self -- x ) self addr @ spi@ ;
\ This methods are early bound to a SpiVar Instance but late bound to the +!
\ and ? methods defined in MemVar, when those are applied to a SpiVar
\ Instance.


forth definitions

\ Some test code to see that late binding in '?' and '+!' really works:

MemVar new a here 0 , a init
SpiVar new b here 1 , b init
FlashVar new c here 2 , c init

cr
cr ." a ? should print: 0"
cr ." " a ?
cr ." b ? should print: spi fetch 1"
cr ." " b ?
cr ." c ? should print: 2"
cr ." " c ?
cr
cr
cr ." 100 a +! a ? should print: 100"
cr ." " 100 a +! a ?
cr ." 200 b +! b ? should print: spi fetch spi store spi fetch 201"
cr ." " 200 b +! b ?
cr
cr ." 300 c +! c ? should print: flash store 302"
cr ." " 300 c +! c ?
cr
FlashVar definitions

\ : @  ( self -- x )  ." flash @ " self addr @ @ ;
: @   ." flash @ " embed @ ;

Forth definitions

FlashVar new d  here 4 , d init

cr ." c ? should print: 302"
cr c ?
cr ." d ? should print: flash @ 4"
cr d ?
cr
